// Created with MonoDevelop
// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2021 Torsten Schache, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

using System;
using System.Linq;

namespace Hiperscan.Extensions.ApoIdent
{
    //With .Net 8.0 can T derived from Enum
    //than is this easier.
    public abstract class StateEnum<T>
    {
        public delegate void StateChangedHandler(T value);
        public event StateChangedHandler StateChanged = null;

        public StateEnum()
        {
            if (this.State is Enum) 
            {
                string name = Enum.GetNames(typeof(T)).FirstOrDefault();
                if (name != "None")
                    throw new Exception("First Member of T must be 'None'.");
            }
            else
            {
                throw new Exception("T must an enum type.");
            }
        }

        public virtual void DeleteFlag(T flag)
        {
            this.StateChanged?.Invoke(this.State);
        }

        public virtual void SetFlag(T flag)
        {
            this.StateChanged?.Invoke(this.State);
        }

        public abstract bool HasFlag(T flag);
    
        public virtual void ResetFlags()
        {
            this.State = default(T);
            this.StateChanged?.Invoke(this.State);
        }


        public T State { get; protected set; } = default(T);
    }
}